﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="EditNewsControl.ascx.cs"
    Inherits="anaii.EasyNews.EditNewsControl" %>
<%@ Register TagPrefix="dnn" TagName="TextEditor" Src="~/controls/TextEditor.ascx" %>
<%@ Register TagPrefix="dnn" TagName="URL" Src="~/controls/URLControl.ascx" %>
<style type="text/css">
    .style1
    {
        height: 31px;
    }
    .style2
    {
        height: 27px;
    }
</style>
<h3>
    NEWS PARAMETERS
</h3>
<br />
<table>
    <tr>
        <td colspan="1">
            Title (100 char) :
        </td>
        <td colspan="3">
            <asp:TextBox ID="txtTitle" runat="server" Width="600" MaxLength="100"></asp:TextBox>
            <asp:RequiredFieldValidator ID="RequiredFieldValidator1" ControlToValidate="txtTitle"
                Display="Dynamic" runat="server" ErrorMessage="Title is required!">*</asp:RequiredFieldValidator>
        </td>
    </tr>
    <tr style="display: none;">
        <td colspan="1">
            Small description (500 char) :
        </td>
        <td colspan="3">
            <asp:TextBox ID="txtSmallDescription" runat="server" Width="600px" MaxLength="500"
                Height="60px" TextMode="MultiLine"></asp:TextBox>
            <asp:RequiredFieldValidator ID="RequiredFieldValidator2" ControlToValidate="txtSmallDescription"
                Display="Dynamic" runat="server" ErrorMessage="Small description is required!" Enabled="false">*</asp:RequiredFieldValidator>
        </td>
    </tr>
    <tr>
        <td colspan="1">
            Left description #1 :
        </td>
        <td colspan="3">
            <dnn:TextEditor ID="txtDescription1" runat="server" Width="600" Height="300">
            </dnn:TextEditor>
            <asp:RequiredFieldValidator ID="RequiredFieldValidator3" ControlToValidate="txtDescription1"
                Display="Dynamic" runat="server" ErrorMessage="Description is required!">*</asp:RequiredFieldValidator>
        </td>
    </tr>
    <tr>
        <td colspan="1">
            Right description #2 :
        </td>
        <td colspan="3">
            <dnn:TextEditor ID="txtDescription2" runat="server" Width="600" Height="300">
            </dnn:TextEditor>
        </td>
    </tr>
    <tr style="display: none;">
        <td colspan="1">
            Image :
        </td>
        <td colspan="3">
            <dnn:URL ID="urlImage" runat="server" Width="300" Required="False" ShowTabs="False"
                ShowFiles="True" ShowImages="False" ShowUrls="False" ShowLog="False" ShowNone="True"
                ShowNewWindow="False" ShowTrack="False" ShowUpLoad="True" />
        </td>
    </tr>
    <tr style="display: none;">
        <td colspan="1">
            Thumbnail :
        </td>
        <td colspan="3">
            <dnn:URL ID="urlThumb" runat="server" Width="300" Required="False" ShowTabs="False"
                ShowFiles="True" ShowImages="False" ShowUrls="False" ShowLog="False" ShowNone="True"
                ShowNewWindow="False" ShowTrack="False" ShowUpLoad="True" />
        </td>
    </tr>
    <tr style="display: none;">
        <td colspan="1">
            Download file :
        </td>
        <td colspan="3">
            <dnn:URL ID="urlFile" runat="server" Width="300" Required="False" ShowTabs="False"
                ShowFiles="True" ShowImages="False" ShowUrls="False" ShowLog="False" ShowNone="True"
                ShowNewWindow="False" ShowTrack="False" ShowUpLoad="True" />
        </td>
    </tr>
    <tr style="display: none;">
        <td colspan="1">
            External URL (500 char) :
        </td>
        <td colspan="3">
            <asp:TextBox ID="txtExternalURL" runat="server" Width="600" MaxLength="500"></asp:TextBox>
        </td>
    </tr>
    <tr>
        <td colspan="1">
            News type :
        </td>
        <td colspan="3">
            <asp:DropDownList ID="ddlType" runat="server" DataSourceID="LinqDataSource1" DataTextField="Name"
                DataValueField="TypeID">
            </asp:DropDownList>
            <asp:LinqDataSource ID="LinqDataSource1" runat="server" ContextTypeName="anaii.EasyNews.Data.EasyNewsDBDataContext"
                OrderBy="Name" Select="new (TypeID, Name)" TableName="EasyNewsTypes">
            </asp:LinqDataSource>
        </td>
    </tr>
    <tr>
        <td colspan="1" class="style1">
            Status :
        </td>
        <td colspan="3" class="style1">
            <asp:RadioButtonList ID="rblStatus" runat="server" RepeatDirection="Horizontal">
                <asp:ListItem Value="1">Published</asp:ListItem>
                <asp:ListItem Value="2">Archive</asp:ListItem>
            </asp:RadioButtonList>
        </td>
    </tr>
    <tr>
        <td colspan="1">
            Date created :
        </td>
        <td colspan="3">
            <asp:TextBox ID="txtDateCreated" runat="server" Width="190px"></asp:TextBox>
            &nbsp;
            <asp:HyperLink ID="cmdCalendar2" CssClass="CommandButton" runat="server">Calendar</asp:HyperLink>
            <asp:CompareValidator ID="cvDateCreated" runat="server" CssClass="NormalRed" ControlToValidate="txtDateCreated"
                ErrorMessage="You have entered an invalid expired date!" Display="Dynamic" Type="Date"
                Operator="DataTypeCheck">*</asp:CompareValidator>
            <asp:RequiredFieldValidator ID="rfvDateCreated" runat="server" ControlToValidate="txtDateCreated"
                ErrorMessage="Date created must be inserted!" Display="Dynamic">*</asp:RequiredFieldValidator>
        </td>
    </tr>
    <tr>
        <td colspan="1">
            Publish Date :
        </td>
        <td colspan="3">
            <asp:TextBox ID="txtPublishDate" runat="server" Width="190px"></asp:TextBox>
            &nbsp;
            <asp:HyperLink ID="cmdCalendar3" CssClass="CommandButton" runat="server">Calendar</asp:HyperLink>
            <asp:CompareValidator ID="cvPublishDate" runat="server" CssClass="NormalRed" ControlToValidate="txtPublishDate"
                ErrorMessage="You have entered an invalid publish date!" Display="Dynamic" Type="Date"
                Operator="DataTypeCheck">*</asp:CompareValidator>   
        </td>
    </tr>
    <tr>
        <td>
            Publish Time :
        </td>
        <td colspan="3" nowrap>
            <asp:TextBox ID="txtPublishTime" runat="server" Width="90px"></asp:TextBox>
            <asp:RegularExpressionValidator ID="revPublishTime" runat="server" ValidationExpression="(^([0-9]|[0-1][0-9]|[2][0-3]):([0-5][0-9])$)|(^([0-9]|[1][0-9]|[2][0-3])$)" CssClass="NormalRed" ControlToValidate="txtPublishTime" ErrorMessage="You have entered an invalid publish time!">*</asp:RegularExpressionValidator>&nbsp Example: 14:00  
        </td>
    </tr>
    <tr>
        <td colspan="1">
            Expired date :
        </td>
        <td colspan="3">
            <asp:TextBox ID="txtExpiredDate" runat="server" Width="190px"></asp:TextBox>
            &nbsp;
            <asp:HyperLink ID="cmdCalendar" CssClass="CommandButton" runat="server">Calendar</asp:HyperLink>
            <asp:CompareValidator ID="valPublishDate" runat="server" CssClass="NormalRed" ControlToValidate="txtExpiredDate"
                ErrorMessage="You have entered an invalid expired date!" Display="Dynamic" Type="Date"
                Operator="DataTypeCheck">*</asp:CompareValidator>
        </td>
    </tr>    
    <tr>
        <td colspan="1" class="style2">
            Enabled :
        </td>
        <td colspan="3" class="style2">
            <asp:CheckBox ID="cbEnabled" runat="server" />
        </td>
    </tr>
</table>
<asp:ValidationSummary ID="ValidationSummary1" runat="server" ShowMessageBox="true" ShowSummary="true" DisplayMode="List"/>
